1,3}(_\d{3})+[kMGTPmunpf]?">
        <token type="LiteralNumberFloat"/>
      </rule>
      <rule pattern="[0-9][0-9]*\.[0-9]+([eE][+-]?[0-9]+)?[kMGTPmunpf]?">
        <token type="LiteralNumberFloat"/>
      </rule>
      <rule pattern="#([0-9a-fA-F]{4})(_[0-9a-fA-F]{4})+">
        <token type="LiteralNumberHex"/>
      </rule>
      <rule pattern="#[0-9a-fA-F]+">
        <token type="LiteralNumberHex"/>
      </rule>
      <rule pattern="\$([01]{4})(_[01]{4})+">
        <token type="LiteralNumberBin"/>
      </rule>
      <rule pattern="\$[01]+">
        <token type="LiteralNumberBin"/>
      </rule>
      <rule pattern="\d{1,3}(_\d{3})+[kMGTP]?">
        <token type="LiteralNumberInteger"/>
      </rule>
      <rule pattern="[0-9]+[kMGTP]?">
        <token type="LiteralNumberInteger"/>
      </rule>
      <rule pattern="\n">
        <token type="Text"/>
      </rule>
    </state>
  </rules>
</lexer>